<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRelatieGegevens ArrayType
 * @subpackage Arrays
 */
class ArrayOfRelatieGegevens extends AbstractStructArrayBase
{
    /**
     * The RelatieGegevens
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RelatieGegevens[]
     */
    public $RelatieGegevens;
    /**
     * Constructor method for ArrayOfRelatieGegevens
     * @uses ArrayOfRelatieGegevens::setRelatieGegevens()
     * @param \StructType\RelatieGegevens[] $relatieGegevens
     */
    public function __construct(array $relatieGegevens = array())
    {
        $this
            ->setRelatieGegevens($relatieGegevens);
    }
    /**
     * Get RelatieGegevens value
     * @return \StructType\RelatieGegevens[]|null
     */
    public function getRelatieGegevens()
    {
        return $this->RelatieGegevens;
    }
    /**
     * Set RelatieGegevens value
     * @throws \InvalidArgumentException
     * @param \StructType\RelatieGegevens[] $relatieGegevens
     * @return \ArrayType\ArrayOfRelatieGegevens
     */
    public function setRelatieGegevens(array $relatieGegevens = array())
    {
        foreach ($relatieGegevens as $arrayOfRelatieGegevensRelatieGegevensItem) {
            // validation for constraint: itemType
            if (!$arrayOfRelatieGegevensRelatieGegevensItem instanceof \StructType\RelatieGegevens) {
                throw new \InvalidArgumentException(sprintf('The RelatieGegevens property can only contain items of \StructType\RelatieGegevens, "%s" given', is_object($arrayOfRelatieGegevensRelatieGegevensItem) ? get_class($arrayOfRelatieGegevensRelatieGegevensItem) : gettype($arrayOfRelatieGegevensRelatieGegevensItem)), __LINE__);
            }
        }
        $this->RelatieGegevens = $relatieGegevens;
        return $this;
    }
    /**
     * Add item to RelatieGegevens value
     * @throws \InvalidArgumentException
     * @param \StructType\RelatieGegevens $item
     * @return \ArrayType\ArrayOfRelatieGegevens
     */
    public function addToRelatieGegevens(\StructType\RelatieGegevens $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RelatieGegevens) {
            throw new \InvalidArgumentException(sprintf('The RelatieGegevens property can only contain items of \StructType\RelatieGegevens, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RelatieGegevens[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RelatieGegevens|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RelatieGegevens|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RelatieGegevens|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RelatieGegevens|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RelatieGegevens|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RelatieGegevens
     */
    public function getAttributeName()
    {
        return 'RelatieGegevens';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRelatieGegevens
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
