<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResultaatContainerOfInt32 StructType
 * @subpackage Structs
 */
class ResultaatContainerOfInt32 extends AbstractStructBase
{
    /**
     * The Succeeded
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Succeeded;
    /**
     * The Resultaat
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Resultaat;
    /**
     * The Errors
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $Errors;
    /**
     * The Warnings
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $Warnings;
    /**
     * Constructor method for ResultaatContainerOfInt32
     * @uses ResultaatContainerOfInt32::setSucceeded()
     * @uses ResultaatContainerOfInt32::setResultaat()
     * @uses ResultaatContainerOfInt32::setErrors()
     * @uses ResultaatContainerOfInt32::setWarnings()
     * @param bool $succeeded
     * @param int $resultaat
     * @param \ArrayType\ArrayOfString $errors
     * @param \ArrayType\ArrayOfString $warnings
     */
    public function __construct($succeeded = null, $resultaat = null, \ArrayType\ArrayOfString $errors = null, \ArrayType\ArrayOfString $warnings = null)
    {
        $this
            ->setSucceeded($succeeded)
            ->setResultaat($resultaat)
            ->setErrors($errors)
            ->setWarnings($warnings);
    }
    /**
     * Get Succeeded value
     * @return bool
     */
    public function getSucceeded()
    {
        return $this->Succeeded;
    }
    /**
     * Set Succeeded value
     * @param bool $succeeded
     * @return \StructType\ResultaatContainerOfInt32
     */
    public function setSucceeded($succeeded = null)
    {
        // validation for constraint: boolean
        if (!is_null($succeeded) && !is_bool($succeeded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($succeeded)), __LINE__);
        }
        $this->Succeeded = $succeeded;
        return $this;
    }
    /**
     * Get Resultaat value
     * @return int
     */
    public function getResultaat()
    {
        return $this->Resultaat;
    }
    /**
     * Set Resultaat value
     * @param int $resultaat
     * @return \StructType\ResultaatContainerOfInt32
     */
    public function setResultaat($resultaat = null)
    {
        // validation for constraint: int
        if (!is_null($resultaat) && !is_numeric($resultaat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($resultaat)), __LINE__);
        }
        $this->Resultaat = $resultaat;
        return $this;
    }
    /**
     * Get Errors value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \ArrayType\ArrayOfString $errors
     * @return \StructType\ResultaatContainerOfInt32
     */
    public function setErrors(\ArrayType\ArrayOfString $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Get Warnings value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getWarnings()
    {
        return $this->Warnings;
    }
    /**
     * Set Warnings value
     * @param \ArrayType\ArrayOfString $warnings
     * @return \StructType\ResultaatContainerOfInt32
     */
    public function setWarnings(\ArrayType\ArrayOfString $warnings = null)
    {
        $this->Warnings = $warnings;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ResultaatContainerOfInt32
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
